import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'mixin/app.dart';
import 'widget/error_retrier.dart';

abstract class YaoService<T> extends GetxService with AppMixin {
  Future<T> run();
}

class YaoView<T> extends StatelessWidget {
  const YaoView({Key? key}) : super(key: key);

  final String? tag = null;

  T get c => GetInstance().find<YaoController>(tag: tag) as T;

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    throw UnimplementedError();
  }

  Widget withState(Widget widget) {
    YaoControllerWithState tmp = c as YaoControllerWithState;
    return tmp.obx((state) => widget,
        onLoading: Builder(
          builder: (BuildContext context) {
            return Center(child: CircularProgressIndicator());
          },
        ),
        onError: (err) => MaterialApp(
            home: Scaffold(
                body: SafeArea(
                    child:
                        (ErrorRetrier(err == null ? "" : err, () async {}))))));
  }
}

abstract class YaoController extends GetxController with AppMixin {}

abstract class YaoControllerWithState<T> extends YaoController
    with StateMixin<T> {}
